<template>
    <div>
        <form @submit.prevent="handleSubmit">
            <div class="box">
                <div class="box-header">
                    <h1>Create section</h1>
                </div>
                <label for="name">Name</label>
                <input id="name" type="text" name="section[name]">
            </div>
            <input type="hidden" name="section[activity_type]" v-if="activity.activity" v-bind:value="activity.activity.activity_type">
            <input type="hidden" name="section[path]" v-bind:value="croppedLinestring"/>
            <div id="map"></div>
            <div class="box">
                <div id="slider"></div>
                <input type="submit">
            </div>
        </form>
    </div>
</template>

<script>
    import L from 'leaflet'
    import axios from 'axios'
    import toGeoJSON from '@mapbox/togeojson'
    import noUiSlider from 'nouislider'
    import 'nouislider/distribute/nouislider.css'

    export default {
        data() {
            return {
                activity: {},
                geoJSON: {},
                fullCoords: {},
                croppedLinestring: {},
                sectionLayer: {},
                map: {},
                slider: {}
            }
        },
        computed: {
            api_key: function() {
                return this.$store.state.applicationSettings.application_settings
                    .find((setting) => setting.application_setting.code === 'mapbox_api_key')
                    .application_setting.text_value
            }
        },
        methods: {
            displayGeoJSON: function () {
                this.$data.sectionLayer = L.geoJSON().addTo(this.$data.map)
                this.$data.sectionLayer.addData(this.$data.geoJSON)
                this.map.fitBounds(this.$data.sectionLayer.getBounds())
            },

            sliceChanged: function (crop_start, crop_end) {
                this.$data.map.removeLayer(this.$data.sectionLayer)
                this.$data.geoJSON.features[0].geometry.coordinates = this.$data.fullCoords.slice(crop_start, crop_end)
                let linestring = "LINESTRING("
                for(let i = 0; i < this.$data.geoJSON.features[0].geometry.coordinates.length; i++) {
                    let coord = this.$data.geoJSON.features[0].geometry.coordinates[i]
                    linestring += coord[0] + " " + coord[1] + " " + coord[2]
                    if (i !== this.$data.geoJSON.features[0].geometry.coordinates.length - 1) {
                        linestring += ", "
                    }
                }

                linestring += ")"
                this.$data.croppedLinestring = linestring
                this.displayGeoJSON()
            },

            handleSubmit: function (event) {
                let formData = new FormData(event.target);
                axios.post('/api/' + 'section', formData).then(
                    function (response) {
                        window.location.replace('/section/' + response.data.section.id);
                    }
                )
            },
            initMap: function () {
                this.map = L.map('map').setView([51.505, -0.09], 13)
                L.tileLayer(`https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=${this.api_key}`, {
                    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                    maxZoom: 18,
                    id: 'mapbox.streets'
                }).addTo(this.map)
            },
            initSlider: function () {
                this.$data.slider = document.getElementById('slider')
                noUiSlider.create(this.$data.slider, {
                    start: [0, 800],
                    connect: true,
                    step: 1,
                    range: {
                        'min': 0,
                        'max': this.$data.fullCoords.length
                    }
                })
                this.$data.slider.noUiSlider.on('update', ( values ) => {
                    this.sliceChanged(values[0], values[1])
                })
            }
        },
        created: function () {
            this.$store.dispatch('show_activity', {params: {id: this.$route.params.id}}).then( activity => {
                this.activity = activity.data
                this.initMap()
                axios({
                    method: 'get',
                    url: this.activity['activity']['activity_log_url'],
                }).then( response => {
                    let parser = new DOMParser();
                    let xmlGpx = parser.parseFromString(response.data, "application/xml");
                    this.$data.geoJSON = toGeoJSON.gpx(xmlGpx)
                    this.$data.fullCoords = this.$data.geoJSON .features[0].geometry.coordinates
                    this.displayGeoJSON(10,-1)
                    this.initSlider()
                })

            }, response => {
                this.$notify({
                    group: 'error',
                    title: 'Error',
                    duration: -1,
                    text: response.response.data.status + " " + response.response.data.error
                });
            })
        }
    }
</script>

<style>
    #map {
        height: 500px
    }

    #slider {
        margin-bottom: 50px
    }
</style>
